Subject: bug#6718: 23.2; Should align glyphs according to grid in ansi-term

From: Stefan Kangas <[email-masked]>
Date: Wed, 18 Nov 2020 20:25:50 -0800

Jonathan Kleinehellefort <[email-masked]> writes:

> I came across this when I tried using the font Inconsolata inside
> ansi-term.  Inconsolata does not cover a couple of special Unicode
> characters, some of which frequently show up in the output of various
> terminal applications.
>
> Emacs will then fall back on some other font with completely different
> geometry for those, destroying the grid layout of the buffer.
>
> Steps to reproduce:
>
>  1. run "emacs -Q"
>  2. M-x term
>  4. type "pstree" into the shell
>  5. Choose "Inconsolata" as your font
>
> Result:
>
> Characters now have non-uniform width and height. Note that the pretty
> tree drawing gets destroyed.
>
> Expected result:
>
> Glyphs should be aligned in a grid.
>
> Using a more comprehensive font (e.g. DejaVu Sans Mono) does not solve
> this completely, as you can still get the same problem with e.g. Chinese
> characters.

Is there really anything that can be done about this, besides a complete
redesign of how fonts work in Emacs?